package com.serval.polsplitter;

import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.ArrayList;
import java.util.Collection;

/**
 * User: tej
 * Date: 4/6/11
 * Time: 10:26 AM
 */
public class PolicySplitterMain implements ActionListener {

    Collection<String> xacmlFiles;

    JFrame mainFrame;
    JTextArea textArea;
    JButton splitThemAllButton, selectAndSplitOneFileButton, filechooserbutton;
    JLabel statusBar;

    JMenuItem selectDirectoryMenu, selectAndSplitMenu, splitPoliciesMenu, exitMenu;
    JMenu helpMenu;
    JMenuItem helpIntemMenu, aboutIntemMenu;


    JCheckBox[] ccList = new JCheckBox[7];
    private static final String[] ccNames = {"S", "A", "R", "SA", "SR", "AR", "SAR"};
    private JButton ccSelectAll,ccDeselectAll;


    public PolicySplitterMain() throws ClassNotFoundException, UnsupportedLookAndFeelException, InstantiationException, IllegalAccessException {


        // init GUI
        initComponents();

    }


    private void initComponents() throws ClassNotFoundException, UnsupportedLookAndFeelException, IllegalAccessException, InstantiationException {

        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

        mainFrame = new JFrame("XACML PolicySplitter ");
        // Add a window listener for close button
        mainFrame.addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

        mainFrame.setPreferredSize(new Dimension(1000, 800));
        mainFrame.getContentPane().setLayout(null);

        // This is an empty content area in the mainFrame
        filechooserbutton = new JButton("Choose directory ");

        filechooserbutton.setPreferredSize(new Dimension(175, 100));

        filechooserbutton.addActionListener(this);

        textArea = new JTextArea(10, 30);

        // text area & buttons

        splitThemAllButton = new JButton("Split policies");
        splitThemAllButton.setEnabled(false);
        splitThemAllButton.addActionListener(this);
        splitThemAllButton.setLocation(new Point(250, 600));
        splitThemAllButton.setSize(new Dimension(200, 30));

        filechooserbutton.setLocation(new Point(50, 50));
        filechooserbutton.setSize(new Dimension(200, 30));
        mainFrame.getContentPane().add(filechooserbutton);

        selectAndSplitOneFileButton = new JButton("Select and split policies");

        mainFrame.getContentPane().add(selectAndSplitOneFileButton);
        selectAndSplitOneFileButton.setLocation(new Point(700, 50));
        selectAndSplitOneFileButton.setSize(new Dimension(200, 30));

        selectAndSplitOneFileButton.addActionListener(this);

        mainFrame.getContentPane().add(filechooserbutton);
        filechooserbutton.setLocation(new Point(400, 50));
        filechooserbutton.setSize(new Dimension(200, 30));

        textArea.setLocation(new Point(100, 100));
        textArea.setSize(new Dimension(800, 400));
        JScrollPane scrollPane = new JScrollPane(textArea);
        scrollPane.setLocation(new Point(100, 100));
        scrollPane.setSize(new Dimension(800, 400));
        mainFrame.getContentPane().add(scrollPane);

        mainFrame.getContentPane().add(splitThemAllButton);

        // check boxes
        JCheckBox ccCheckboxTmp;
        for (int i = 0; i < ccList.length; i++) {
            ccCheckboxTmp = new JCheckBox(ccNames[i]);
            // ccCheckboxTmp.setName(ccNames[i]);

            ccCheckboxTmp.setLocation(new Point(650, 520 + 30 * i));
            ccCheckboxTmp.setSize(60, 30);
            ccCheckboxTmp.addActionListener(this);
            ccCheckboxTmp.setSelected(true);

            ccList[i] = ccCheckboxTmp;
            mainFrame.getContentPane().add(ccCheckboxTmp);
        }

        // select and unselect all
        ccSelectAll = new JButton("Select all");
        ccSelectAll.setLocation(new Point(730, 570));
        ccSelectAll.setSize(150, 30);
        ccSelectAll.addActionListener(this);
        mainFrame.getContentPane().add(ccSelectAll);

        ccDeselectAll = new JButton("Deselected all");
        ccDeselectAll.setLocation(new Point(730, 630));
        ccDeselectAll.setSize(150, 30);
        ccDeselectAll.addActionListener(this);
        mainFrame.getContentPane().add(ccDeselectAll);

        // menues

        // Creates a menubar for a JFrame
        JMenuBar menuBar = new JMenuBar();

        // Add the menubar to the frame
        mainFrame.setJMenuBar(menuBar);

        // Define and add two drop down menu to the menubar
        JMenu fileMenu = new JMenu("File");
        helpMenu = new JMenu("?");

        menuBar.add(fileMenu);
        menuBar.add(helpMenu);

        helpIntemMenu = new JMenuItem("Help");
        helpIntemMenu.addActionListener(this);

        aboutIntemMenu = new JMenuItem("About");
        aboutIntemMenu.addActionListener(this);

        helpMenu.add(helpIntemMenu);
        helpMenu.add(aboutIntemMenu);

        // Create and add simple menu item to one of the drop down menu

        selectDirectoryMenu = new JMenuItem("Select directory");
        selectDirectoryMenu.setAccelerator(KeyStroke.getKeyStroke('D', InputEvent.CTRL_DOWN_MASK));
        selectDirectoryMenu.addActionListener(this);

        selectAndSplitMenu = new JMenuItem("Select and split policies");
        selectAndSplitMenu.setAccelerator(KeyStroke.getKeyStroke('W', InputEvent.CTRL_DOWN_MASK));
        selectAndSplitMenu.addActionListener(this);

        splitPoliciesMenu = new JMenuItem("Split policies");
        splitPoliciesMenu.setAccelerator(KeyStroke.getKeyStroke('S', InputEvent.CTRL_DOWN_MASK));
        splitPoliciesMenu.setEnabled(false);
        splitPoliciesMenu.addActionListener(this);


        exitMenu = new JMenuItem("Exit");
        exitMenu.setAccelerator(KeyStroke.getKeyStroke('Q', InputEvent.CTRL_DOWN_MASK));
        exitMenu.addActionListener(this);


        fileMenu.add(selectDirectoryMenu);
        fileMenu.add(selectAndSplitMenu);
        fileMenu.addSeparator();
        fileMenu.add(splitPoliciesMenu);
        fileMenu.addSeparator();
        fileMenu.add(exitMenu);

        statusBar = new JLabel();
        statusBar.setLocation(new Point(10, 730));
        statusBar.setSize(new Dimension(1000, 30));
        statusBar.setText("Ready. ");

        mainFrame.getContentPane().add(statusBar);
        mainFrame.setResizable(false);
        ((JComponent) mainFrame.getContentPane()).setBorder(BorderFactory.createLoweredBevelBorder());
        mainFrame.pack();
        mainFrame.setLocation(Toolkit.getDefaultToolkit().getScreenSize().width / 2 - mainFrame.getWidth() / 2, Toolkit.getDefaultToolkit().getScreenSize().height / 2 - mainFrame.getHeight() / 2);
        mainFrame.setVisible(true);


    }


    /**
     * gets the selected CC in checkboxes and puts them in a collection
     *
     * @return the collection with the selected CC
     */
    private Collection<String> readSelectedCC() {

        Collection<String> selectedCCs = new ArrayList<String>();

        // get select ones
        for (JCheckBox ccElement : ccList) {

            if (ccElement.isSelected()) {
                selectedCCs.add(ccElement.getText());
                System.out.println(ccElement.getText());
            }
        }
        return selectedCCs;
    }


    public void actionPerformed(ActionEvent actionEvent) {

        if (actionEvent.getSource() == ccSelectAll) {
            // select all
            for (JCheckBox aCcList : ccList) {
                aCcList.setSelected(true);

            }


        } else if (actionEvent.getSource() == ccDeselectAll) {
            // select all
            for (JCheckBox aCcList : ccList) {
                aCcList.setSelected(false);
            }

        } else if (actionEvent.getSource() == splitThemAllButton || actionEvent.getSource() == splitPoliciesMenu) {

            // if no files don"t go on
            if (!xacmlFiles.isEmpty()) {

                textArea.setText("Splitting...");
                statusBar.setText("Splitting...");
                statusBar.repaint();
                mainFrame.repaint();
                mainFrame.setEnabled(false);

                Collection<String> selectedCCs =  readSelectedCC();

                if(selectedCCs.isEmpty()) {

                textArea.setText("You need to select at least one splitting criterion");
                return;

                }

                PolicySplitter.splitPoliciesInCollection(xacmlFiles,selectedCCs);
                mainFrame.setEnabled(true);

                splitThemAllButton.setEnabled(false);
                splitPoliciesMenu.setEnabled(false);

                textArea.setText("Done! result is in the directory ");
                statusBar.setText("Ready.");

            }

        } else if (actionEvent.getSource() == filechooserbutton || actionEvent.getSource() == selectDirectoryMenu) {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            int returnVal = fileChooser.showOpenDialog(mainFrame);
            if (returnVal == JFileChooser.APPROVE_OPTION) {

                File file = fileChooser.getSelectedFile();

                System.out.println("Chosen fie " + file.getAbsolutePath());

                // start searching for xml files
                textArea.setText("Searching...");
                statusBar.setText("Searching...");

                xacmlFiles = Utils.findXACMLsInDirectory(file.getAbsolutePath());

                StringBuffer text = new StringBuffer("");
                for (String xacmlFile : xacmlFiles) {
                    text.append(xacmlFile).append("\n");
                }

                textArea.setText(text.toString());
                splitThemAllButton.setEnabled(true);

                String textstatus;
                if (xacmlFiles.isEmpty())
                    textstatus = "Found " + xacmlFiles.size();
                else if (xacmlFiles.size() == 1)
                    textstatus = "Found only one xml file";
                else
                    textstatus = "Found " + xacmlFiles.size() + " xml files";

                statusBar.setText(textstatus + " in " + file.getAbsolutePath());

                splitPoliciesMenu.setEnabled(true);
            }


        } else if (actionEvent.getSource() == selectAndSplitOneFileButton || actionEvent.getSource() == selectAndSplitMenu) {

            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);

            fileChooser.setMultiSelectionEnabled(true);
            fileChooser.setAcceptAllFileFilterUsed(false);
            // show only XML files (hopefully XML
            fileChooser.addChoosableFileFilter(new FileFilter() {
                @Override
                public boolean accept(File fileToFilter) {
                    if (fileToFilter.isDirectory())
                        return true;

                    String ext;
                    String s = fileToFilter.getName();
                    int i = s.lastIndexOf('.');

                    if (i > 0 && i < s.length() - 1) {
                        ext = s.substring(i + 1).toLowerCase();
                        if (ext.equals("xml"))
                            return true;
                    }
                    return false;
                }

                @Override
                public String getDescription() {
                    return "XML files";
                }
            });


            int returnVal = fileChooser.showOpenDialog(mainFrame);

            if (returnVal == JFileChooser.APPROVE_OPTION) {

                File[] files = fileChooser.getSelectedFiles();

                // prepare the collection
                xacmlFiles = new ArrayList<String>();
                for (File file : files) {
                    xacmlFiles.add(file.getAbsolutePath());
                }

                textArea.setText("Splitting...");
                statusBar.setText("Splitting...");
                statusBar.repaint();
                mainFrame.repaint();
                // do it
                textArea.setText("Performing splitting... ");
                textArea.repaint();

                Collection<String> selectedCCs =  readSelectedCC();


                if(selectedCCs.isEmpty()) {

                textArea.setText("You need to select at least one splitting criterion");
                return;

                }

                PolicySplitter.splitPoliciesInCollection(xacmlFiles,selectedCCs);
                textArea.setText("Done! result is in the directory ");

                statusBar.setText("Ready.");

            }

        } else if (actionEvent.getSource() == exitMenu) {

            mainFrame.dispose();
            System.exit(0);

        } else if (actionEvent.getSource() == helpIntemMenu) {
            // TODO
        } else if (actionEvent.getSource() == aboutIntemMenu) {

            JOptionPane.showMessageDialog(mainFrame, "PolicySplitter v0.4 Beta \nCreate by Dr. Tejeddine Mouelhi\nresearch " +
                    "associate at SnT, University of Luxembourg\n May 2011", null, JOptionPane.INFORMATION_MESSAGE);
        }
    }


    public static void main(String[] args) throws ClassNotFoundException, UnsupportedLookAndFeelException, InstantiationException, IllegalAccessException {
        new PolicySplitterMain();
    }

}
