package com.serval.polsplitter;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import java.io.*;
import java.util.Arrays;
import java.util.regex.Pattern;


public class XACMLTransformer {


    private static void transformXACMLFile(String filename, String targetElement, String cluster) {

        // check parameters
        if (cluster == null || cluster.equals(""))
            return;

        System.out.println(filename);

        CharSequence subject = "S";
        CharSequence action = "A";
        CharSequence resource = "R";
        String chaine_rep = "";
        String index_debut = "";
        String index_fin = "";
        String tagname = "";
        int insertion_debut = 0;
        int index_supp = 0;

        if (targetElement.equals(subject)) {

            //System.out.println(cluster);
            tagname = "Subjects";
            index_debut = "<Subjects>";
            index_fin = "</Subjects>";
            chaine_rep = "<AnySubject/>";
            insertion_debut = 10;
            index_supp = 13;

        } else if (targetElement.equals(action)) {
            tagname = "Actions";
            index_debut = "<Actions>";
            index_fin = "</Actions>";
            chaine_rep = "<AnyAction/>";
            insertion_debut = 9;
            index_supp = 12;
        } else if (targetElement.equals(resource)) {
            tagname = "Resources";
            index_debut = "<Resources>";
            index_fin = "</Resources>";
            chaine_rep = "<AnyResource/>";
            insertion_debut = 11;
            index_supp = 14;
        }


        try {

            File file = new File(filename);
            String monFile = "";
            String MonFile1;
            String res = "";
            boolean result = false;

            //  boolean test =true;
            if (file.exists()) {

                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                DocumentBuilder builder = factory.newDocumentBuilder();

                Document doc = builder.parse(filename);
                TransformerFactory tranFactory = TransformerFactory.newInstance();
                Transformer aTransformer = tranFactory.newTransformer();

                // Get nodes list of all elements
                NodeList list = doc.getElementsByTagName(tagname);
                for (int i = 0; i < list.getLength(); i++) {
                    if (!result) { // Get element
                        Element element = (Element) list.item(i);
                        Source src = new DOMSource(element);

                        // System.out.println("Node no: " + i + " is " + element.getNodeName());

                        Result dest = new StreamResult("temp.xml");
                        aTransformer.transform(src, dest);
                        monFile = readFileAsString("temp.xml");
                        // monFile = PolicySplitter.removeReservedCharsFromString(monFile);

                        // System.out.println(monFile);

                        // remove illegal char and see if equals
                        result = monFile.contains(cluster);
                        // System.out.println(result);
                    }
                    System.out.println(monFile);
                    int debut = monFile.indexOf(index_debut);
                    int fin = monFile.indexOf(index_fin);
                    res = monFile.substring(debut + insertion_debut, fin);
                    System.out.println(res);

                }

                MonFile1 = readFileAsString(filename);
                int debut1 = MonFile1.indexOf(index_debut);
                int deletion = MonFile1.indexOf(chaine_rep);
                // System.out.println(debut1);
                StringBuffer MonFile_b = new StringBuffer(MonFile1);
                StringBuffer res_b = new StringBuffer(res);
                MonFile_b.delete(deletion, deletion + index_supp);
                MonFile_b.insert(debut1 + insertion_debut, res_b);
                // MonFile_b.insert(debut1 + insertion_debut, res_b);
                // System.out.println(MonFile_b);

                if (result) {
                    EcrireFichierXML(MonFile_b.toString(), filename);
                }
            } else {
                System.out.println(filename + " (file name) doesn't found!");
            }
        } catch (Exception e) {
            e.getMessage();
        }
    }


    private static String readFileAsString(String filePath)
            throws java.io.IOException {
        StringBuffer fileData = new StringBuffer(1000);
        BufferedReader reader = new BufferedReader(
                new FileReader(filePath));
        char[] buf = new char[1024];
        int numRead;
        while ((numRead = reader.read(buf)) != -1) {
            String readData = String.valueOf(buf, 0, numRead);
            fileData.append(readData);
            buf = new char[1024];
        }
        reader.close();
        return fileData.toString();
    }

    private static void EcrireFichierXML(String string, String final_output) throws IOException {

        PrintWriter ecrivain;
        ecrivain = new PrintWriter(new BufferedWriter
                (new FileWriter(final_output)));
        ecrivain.println(string);
        ecrivain.close();
    }

    private static String[] extractTags(String fileName) {

        String subject = "", action = "", resource = "";

        String tag = "", tags[] = {"_S_", "_A_", "_R_", "_SA_", "_SR_", "_AR_", "_SAR_"};
        String[][] elements = {{subject}, {action}, {resource}, {subject, action}, {subject, resource}, {action, resource}, {subject, action, resource}};

        Pattern pattern = Pattern.compile("_");
        String[] items = pattern.split(fileName.substring(0, fileName.lastIndexOf(".")));
        int tagIndex = 0;


        for (int i = 0; i < tags.length; i++) {
            if (fileName.contains(tags[i])) {
                tag = tags[i];
                tagIndex = i;
                break;

            }
        }

        int i = 1;
        while (i <= tag.length() - 2) {

            System.out.println(items[items.length - i]);

            elements[tagIndex][elements[tagIndex].length - i] = new String(items[items.length - i]);
            i++;
        }

        // show the three items
        // System.out.println("Subject ===> " + subject);
        //System.out.println("Action ===> " + action);
        //System.out.println("Resource ===> " + resource);

        if (tag.equals("_S_")) {

            subject = elements[tagIndex][0];

        } else if (tag.equals("_A_")) {

            action = elements[tagIndex][0];

        } else if (tag.equals("_R_")) {

            resource = elements[tagIndex][0];

        } else if (tag.equals("_SA_")) {

            subject = elements[tagIndex][0];
            action = elements[tagIndex][1];

        } else if (tag.equals("_AR_")) {

            action = elements[tagIndex][0];
            resource = elements[tagIndex][1];

        } else if (tag.equals("_SR_")) {

            subject = elements[tagIndex][0];
            resource = elements[tagIndex][1];

        } else if (tag.equals("_SAR_")) {

            subject = elements[tagIndex][0];
            action = elements[tagIndex][1];
            resource = elements[tagIndex][2];
        }

        return new String[]{subject, action, resource};
    }


    public static void updateTargetInPolicyFile(String fileName) {


        String tags[] = extractTags(fileName.toString());

        // do transformation
        transformXACMLFile(fileName.toString(), "S", tags[0]);
        transformXACMLFile(fileName.toString(), "A", tags[1]);
        transformXACMLFile(fileName.toString(), "R", tags[2]);

    }


    public static void main(String[] args) {

        String filename;
        String resource, action, subject, tag;


        File[] list = new File("/home/tej/tmp/xacml-subjects/archon/pluto_splitted").listFiles();


        for (File fileName : list) {

            System.out.println("FOR FILE >>>> " + fileName.toString());
            String tags[] = extractTags(fileName.toString());
            System.out.println(Arrays.toString(tags));
            System.out.println("-------------------------------------------------------------------");

            // do transformation
            transformXACMLFile(fileName.toString(), "S", tags[0]);
            transformXACMLFile(fileName.toString(), "A", tags[1]);
            transformXACMLFile(fileName.toString(), "R", tags[2]);

        }


    }
}
