package com.serval.polsplitter.structs;

/**
 * User: tej
 * Date: Mar 29, 2011
 * Time: 1:31:49 PM
 */
public class Attribute {

    private String id;
    private String value;

    
    public Attribute(String id, String value) {
        this.id = id;
        this.value = value;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Attribute attribute = (Attribute) o;

        if (id != null ? !id.equals(attribute.id) : attribute.id != null) return false;
        if (value != null ? !value.equals(attribute.value) : attribute.value != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id != null ? id.hashCode() : 0;
        result = 31 * result + (value != null ? value.hashCode() : 0);
        return result;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String toShortString() {
        return value;
    }


    @Override
    public String toString() {
        return "ID: " + id + " , Value: " + value;
    }
}
