package com.serval.polsplitter.structs;

import java.util.ArrayList;
import java.util.Collection;

/**
 * User: tej
 * Date: Mar 29, 2011
 * Time: 5:19:11 PM
 */
public class Target {


    Collection<TargetElement> subjects;
    Collection<TargetElement> actions;
    Collection<TargetElement> resources;


    public Target() {
        this(new ArrayList<TargetElement>(),new ArrayList<TargetElement>(),new ArrayList<TargetElement>());
    }

    public Target(Collection<TargetElement> subjects, Collection<TargetElement> actions, Collection<TargetElement> resources) {
        this.subjects = subjects;
        this.actions = actions;
        this.resources = resources;
    }

    public Collection<TargetElement> getSubjects() {
        return subjects;
    }

    public void setSubjects(Collection<TargetElement> subjects) {
        this.subjects = subjects;
    }

    public Collection<TargetElement> getActions() {
        return actions;
    }

    public void setActions(Collection<TargetElement> actions) {
        this.actions = actions;
    }

    public Collection<TargetElement> getResources() {
        return resources;
    }

    public void setResources(Collection<TargetElement> resources) {
        this.resources = resources;
    }




    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Target target = (Target) o;

        if (actions != null ? !actions.equals(target.actions) : target.actions != null) return false;
        if (resources != null ? !resources.equals(target.resources) : target.resources != null) return false;
        if (subjects != null ? !subjects.equals(target.subjects) : target.subjects != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = subjects != null ? subjects.hashCode() : 0;
        result = 31 * result + (actions != null ? actions.hashCode() : 0);
        result = 31 * result + (resources != null ? resources.hashCode() : 0);
        return result;


    }


    /**
     * transforms object to short string
     * @return a short string with the object
     */
    public String toShordString() {

        String result;
        result = "";

        for (TargetElement element : subjects) {
            result += element.toShortString();
        }

        for (TargetElement element : actions) {
            result += element.toShortString();
        }

        for (TargetElement element : resources) {
            result += element.toShortString();
        }

        return result;
    }

    @Override
    public String toString() {

        String result;

        result = "Target : ";

        result += "\n\tSubjects : " + subjects.size() + " ";
        for (TargetElement element : subjects) {
            result += element.toString();
        }

        result += "\n\tActions : " + actions.size() + " ";
        for (TargetElement element : actions) {
            result += element.toString();
        }

        result += "\n\tResources : " + resources.size() + " ";
        for (TargetElement element : resources) {
            result += element.toString();
        }

        return result;
    }
}
