package com.serval.polsplitter.structs;

import java.util.ArrayList;
import java.util.Collection;

/**
 * User: tej
 * Date: Mar 29, 2011
 * Time: 1:36:30 PM
 */
public class TargetElement {



    private Collection<Attribute> attributes;

    public TargetElement() {
        this(new ArrayList<Attribute>());
    }

    public TargetElement(Collection<Attribute> attributes) {
        this.attributes = attributes;
    }

    public Collection<Attribute> getAttributes() {
        return attributes;
    }

    public void setAttributes(Collection<Attribute> attributes) {
        this.attributes = attributes;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TargetElement that = (TargetElement) o;

        if (attributes != null ? !attributes.equals(that.attributes) : that.attributes != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return attributes != null ? attributes.hashCode() : 0;
    }

    public String toShortString() {
        String output;

        output = "";

        for (Attribute attribute : attributes) {
            output += attribute.toShortString() + "_";
        }

        return output;
    }


    @Override
    public String toString() {
        String output;

        output = "[";

        for (Attribute attribute : attributes) {
            output += attribute.toString();
        }

        output += "]";

        return output;
    }
}
